package ink.wgink.code.factory.utils;

import com.sun.javafx.robot.FXRobot;
import com.sun.javafx.robot.impl.FXRobotHelper;
import javafx.application.Platform;
import javafx.beans.property.ReadOnlyBooleanProperty;
import javafx.beans.property.ReadOnlyDoubleProperty;
import javafx.beans.property.ReadOnlyObjectProperty;
import javafx.beans.property.ReadOnlyStringProperty;
import javafx.concurrent.Service;
import javafx.concurrent.Task;
import javafx.concurrent.Worker;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;
import javafx.scene.layout.StackPane;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.StageStyle;

import javax.xml.soap.Text;
import java.util.Stack;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: MessageUtil
 * @Description: 消息工具
 * @Author: WangGeng
 * @Date: 2021/3/3 21:25
 * @Version: 1.0
 **/
public class MsgUtil {

    /**
     * 错误
     *
     * @param msg
     */
    public static void errorAlert(String msg) {
        alert(AlertType.NONE, msg);
    }

    /**
     * 确定
     *
     * @param alertType
     * @param msg
     */
    public static void alert(Alert.AlertType alertType, String msg) {

        Alert alert = new Alert(alertType, msg, ButtonType.CLOSE);
        alert.setTitle("提示");
        alert.getDialogPane().setPrefWidth(150);
        alert.show();
    }

    /**
     * 提醒
     *
     * @param msg
     */
    public static void msg(final String msg) {
        HBox hBox = new HBox();
        hBox.setPadding(new Insets(5, 5, 5, 5));
        hBox.setAlignment(Pos.CENTER);

        Label label = new Label(msg);
        label.setId("msgLabel");
        hBox.getChildren().add(label);
        Stage stage = new Stage(StageStyle.UNDECORATED);
        stage.setScene(new Scene(hBox));
        stage.show();

//        Platform.runLater(() -> {
//            // 子线程更新主线程UI的代码
//            stage.close();
//        });
        //

        // 这种方式提倡，call中编写代码，successed方法中填写刷新UI的操作，
        Service<String> service = new Service<String>() {
            @Override
            protected Task<String> createTask() {
                return new Task<String>() {
                    @Override
                    protected String call() throws Exception {
                        Thread.sleep(2000);
                        return "success";
                    }

                    @Override
                    protected void scheduled() {
                        // 任务开始， 填写刷新UI的操作
                        super.scheduled();
                    }

                    @Override
                    protected void running() {
                        // 任务执行
                        super.running();
                    }

                    // 任务成功之后，关闭提示
                    @Override
                    protected void succeeded() {
                        // 任务执行成功
                        stage.close();
                        super.succeeded();
                    }
                };
            }
        };
        service.start();

    }

}
